//----------------------------------------------------------------
// GUI main Frame
// Eksempel p brug af ObjectListBox
// Programmr: Bjrk Busch nov.1999
//----------------------------------------------------------------

import bjbupack.gui.*;
import javabook.Convert;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Iterator;

public	class GuiMainFrame extends Frame
{
	// Skrmdata
	private Button 		knapPerson	=	new Button("Vlg Personer");
	private Button 		knapPost	=	new Button("Vlg Post");
	
	private TextArea 	tekstArea1		= new TextArea ("Events\n",8,50);


	// Forretningsobjekter / model
	private	Vector	persontab	= new	Vector(10,10);	//start=10, vkst=10
	private	Vector	posttab	= new	Vector(10,10);	//start=10, vkst=10


	public GuiMainFrame ()			/* constructor */
	{
		initTestData();

		// opbygning af skrmbillede
		setSize(800,600);
		setTitle("Eksempel p brug af ObjectListBox  -  udarbejdet af Bjrk Busch");
		setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));		

		add(tekstArea1);


		add(knapPerson);
		knapPerson.addActionListener(new knapPersonActionListener());

		add(knapPost);
		knapPost.addActionListener(new knapPostActionListener());



	}

	private void	initTestData()
	{
		persontab.add(new	Person("Bjrk", 43, 'M'));
		persontab.add(new	Person("Ole", 45, 'M'));
		persontab.add(new	Person("Ulla", 38, 'F'));
		persontab.add(new	Person("Susanne", 44, 'F'));
		persontab.add(new	Person("Helge", 61, 'M'));
		persontab.add(new	Person("Susanne", 44, 'F'));
		persontab.add(new	Person("Anders", 9, 'M'));
		persontab.add(new	Person("Astrid", 6, 'F'));
		persontab.add(new	Person("Bjrk2", 43, 'M'));
		persontab.add(new	Person("Ole2", 45, 'M'));
		persontab.add(new	Person("Ulla2", 38, 'F'));
		persontab.add(new	Person("Susanne2", 44, 'F'));
		persontab.add(new	Person("Helge2", 61, 'M'));
		persontab.add(new	Person("Susanne2", 44, 'F'));
		persontab.add(new	Person("Anders2", 9, 'M'));
		persontab.add(new	Person("Astrid2", 6, 'F'));
		
		posttab.add(new	Postdistrikt(5000,"Odense C"));
		posttab.add(new	Postdistrikt(5200,"Odense V"));
		posttab.add(new	Postdistrikt(5210,"Odense NV"));
		posttab.add(new	Postdistrikt(8000,"rhus C"));
	}

	private Frame	getFrame()
	{
		return this;
	}

	private	class knapPersonActionListener implements java.awt.event.ActionListener
	{
	  public void actionPerformed(ActionEvent e)
		{
				SelectDialog	selectDialog	= new SelectDialog(getFrame(),"Personudvlgelse",
																					 true, persontab.iterator(),
																						 10, true);
		
				selectDialog.show();
		
				Object[]	ov	=	selectDialog.getSelectedObjects();
				if (ov != null)
				{
					for	(int i=0;	i<ov.length;	i++)
					{
						Person	p	=	(Person)ov[i];
						tekstArea1.append("navn:"+p.getName()+" alder:"+p.getAge()+"\n");
					}
				}
		}
	}

	private	class knapPostActionListener implements java.awt.event.ActionListener
	{
	  public void actionPerformed(ActionEvent e)
		{
				SelectDialog	selectDialog	= new SelectDialog(getFrame(),"Postdistriktudvlgelse",
																					 true, posttab.iterator(),
																						 10, true);
		
				selectDialog.show();
		
				Object[]	ov	=	selectDialog.getSelectedObjects();
				if (ov != null)
				{
					for	(int i=0;	i<ov.length;	i++)
					{
						Postdistrikt	p	=	(Postdistrikt)ov[i];
						tekstArea1.append("Postnr/by:"+p.getPostnr()+" "+p.getDistrikt()+"\n");
					}
				}
		}
	}

	class DisposeFrameClosingListener extends WindowAdapter
	{
		public void windowClosing(WindowEvent e)
		{
			e.getWindow().dispose();
		};
	}


} // slut p frame-klasse
